/* qmaboutdialog.cpp
 *
 * $Id: qmaboutdialog.cpp,v 1.6 2000/12/13 18:18:36 mariuss Exp $
 *
 * Apollo sound player: http://www.apolloplayer.org
 * Copyright(C) 2000 Apollo Team.  See CREDITS file.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The GNU General Public License is also available online at:
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#include "qmaboutdialog.h"

#include <qlabel.h>
#include <qlayout.h>
#include <qpixmap.h>
#include <qpushbutton.h>

#include "icons/apollo.xpm"
#include "version.h"

/*! \file qmaboutdialog.cpp
  Implementation of QmAboutDialog class which handles the About dialog.
*/

/*!
  \class QmAboutDialog qmaboutdialog.h
  \brief


*/


/*!

*/

QmAboutDialog::QmAboutDialog(
	QWidget *parent,
	const char *name,
	bool modal)
	: QDialog(parent, name, modal)
{
	QVBoxLayout *main 	= new QVBoxLayout(this, 4);
	QHBoxLayout *top  	= new QHBoxLayout;
	QHBoxLayout *bottom = new QHBoxLayout;

	setCaption(tr("About Apollo"));
	setBackgroundColor(white);
	
	QLabel *logo = new QLabel(this);
	logo->setPixmap(QPixmap(apollo_xpm));
	logo->setBackgroundColor(white);

	QLabel *text = new QLabel(
		tr("<center>"
		   "Version %1<br>"
		   "Distributed under GPL<br>"
		   "</center>"
		   "<hr/>"
		   "<table>"
		   "<tr>"
		   "<td>Developers:</td><td>Marius Sundbakken<br>Jan Borsodi</td>"
		   "</tr>"
		   "<tr>"
		   "<td>Icons:</td><td>Heikki Ylinen</td>"
		   "</tr>"
		   "<tr>"
		   "<td>Logo:</td><td>Youngjin Hahn</td>"
		   "</tr>"
		   "<tr><td></td><td></td></tr>"
		   "<tr>"
		   "<td>Contact:</td><td>team@apolloplayer.org</td>"
		   "</tr>"
		   "<tr><td></td><td></td></tr>"
		   "<tr>"
		   "<td>Homepage:</td>"
		   "<td><a href=\"http://apolloplayer.sourceforge.net\">http://www.apolloplayer.org</a></td>"
		   "</tr>"
		   "<tr>"
		   "<td>Report bugs:</td>"
		   "<td><a href=\"http://bugs.apolloplayer.org\">http://bugs.apolloplayer.org</a> or send mail to<br>"
		   "bugs@apolloplayer.org</td>"
		   "</tr>"
		   "<tr>"
		   "<td>Request support:</td>"
		   "<td><a href=\"http://support.apolloplayer.org\">http://support.apolloplayer.org</a></td>"
		   "</tr>"
		   "<tr>"
		   "<td>Download center:</td>"
		   "<td><a href=\"http://download.apolloplayer.org\">http://download.apolloplayer.org</a></td>"
		   "</tr>"
		   "<tr>"
		   "<td>Documentation:</td>"
		   "<td><a href=\"http://docs.apolloplayer.org\">http://docs.apolloplayer.org</a></td>"
		   "</tr>"
		   "<tr>"
		   "<td>Mailing lists:</td>"
		   "<td><a href=\"http://lists.apolloplayer.org\">http://lists.apolloplayer.org</a></td>"
		   "</tr>"
		   "<tr>"
		   "<td>GPL license:</td>"
		   "<td><a href=\"http://www.gnu.org/copyleft/gpl.html\">http://www.gnu.org/copyleft/gpl.html</a></td>"
		   "</tr>"
		   "</table>"
		   "<hr/>"
		   "<p>").arg(APOLLO_VERSION_STR),
		this);
	text->setBackgroundColor(white);
	text->setMinimumSize(text->sizeHint());

	QPushButton *close = new QPushButton("&Close", this);
	close->setDefault(true);
	connect(close, SIGNAL(clicked()), this, SLOT(close()));
	
	main->addLayout(top);
	top->addStretch(1);
	top->addWidget(logo);
	top->addStretch(1);
	main->addWidget(text);
	main->addLayout(bottom);
	bottom->addStretch(1);
	bottom->addWidget(close);
	bottom->addStretch(1);	
}


/*!

*/

QmAboutDialog::~QmAboutDialog()
{
}
