/* ;-*-c++-*-
 *
 * qmdirtree.h
 *
 * $Id: qmdiritem.h,v 1.7 2000/12/09 12:12:36 amos Exp $
 * 
 * Apollo sound player: http://www.apolloplayer.org
 * Copyright(C) 2000 Apollo Team.  See CREDITS file.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The GNU General Public License is also available online at:
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef QMDIRITEM_H_INCLUDED
#define QMDIRITEM_H_INCLUDED

#include <qdir.h>

#include "qmplaylistitem.h"

/*! \file qmdiritem.h
  Definition of QmDirItem class which represents a directory in the directory tree browser.
*/

class QmDirItem : public QmPlayListItem
{
public:
    QmDirItem(QListView *parent, const char *path, int count = -1);
    QmDirItem(QmDirItem *parent, const char *path, int count = -1);

	QString		save() const;
	bool		isSong() const;
    QString		text(int column) const;
    QString 	fullName();
    void 		setOpen(bool open);
    void 		setup();

    virtual QString key( int col, bool asc ) const;

private:
	QDir		m_Dir;
};

#endif // QMDIRITEM_H_INCLUDED
