/* ;-*-c++-*-
 * qmplaylist.h
 *
 * $Id: qmplaylist.h,v 1.8 2000/12/15 09:59:38 amos Exp $
 *
 * Apollo sound player: http://www.apolloplayer.org
 * Copyright(C) 2000 Apollo Team.  See CREDITS file.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The GNU General Public License is also available online at:
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef QMPLAYLIST_H_INCLUDED
#define QMPLAYLIST_H_INCLUDED

#include <qlistview.h>

/*! \file qmplaylist.h
  Definition of QmPlayList class which represents the playlist.
*/

class QmSongItem;

class QmPlayList : public QListView
{
	Q_OBJECT
public:
    QmPlayList(QWidget *parent = 0, const char *name = 0);
    virtual ~QmPlayList();

	virtual void		setSelected(QListViewItem *item, bool selected);
    virtual bool 		save(const QString &filename);
    virtual bool 		load(const QString &filename);
	virtual QmSongItem* nextSong();
	virtual QmSongItem* prevSong();
	virtual QmSongItem*	removeCurrentItem(bool *stop_playing);
	virtual void		clear();
	QmSongItem*			playingSong();
	
    static int count();

    bool atBeginning() const;
    bool atEnd() const;

signals:
	void disableNext();
	void enableNext();
	void disablePrev();
	void enablePrev();

public slots:
	void setPlaying(QListViewItem *item);

protected:
	virtual QmSongItem* nextSong(QListViewItem *startitem) const;
	virtual QmSongItem* prevSong(QListViewItem *startitem) const;
	
private:
    static int 	 s_PlayListCounter;
    QmSongItem	*m_pPlayingItem;
};

#endif // QMPLAYLIST_H_INCLUDED
