/* ;-*-c++-*-
 * 
 * qmplaylistitem.h
 *
 * $Id: qmplaylistitem.h,v 1.5 2000/12/10 11:36:30 amos Exp $
 * 
 * Apollo sound player: http://www.apolloplayer.org
 * Copyright(C) 2000 Apollo Team.  See CREDITS file.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The GNU General Public License is also available online at:
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef QMPLAYLISTITEM_H_INCLUDED
#define QMPLAYLISTITEM_H_INCLUDED

#include <qlistview.h>

/*! \file qmplaylistitem.h
  Definition of QmPlayListItem class which represents an item in the play list.
*/

class QString;

class QmPlayListItem : public QListViewItem
{
public:
	virtual ~QmPlayListItem();

	virtual QString	save() const = 0;
	virtual bool	isSong() const  = 0;

    int sortCounter() const;
    QString sortCounterString() const;
	
protected:
	QmPlayListItem(QListView *parent, int count);
	QmPlayListItem(QmPlayListItem *parent, int count);

private:
    int m_Count;
};

#endif // QMPLAYLISTITEM_H_INCLUDED
