/* ;-*-c++-*-
 * qmsongitem.h
 *
 * $Id: qmsongitem.h,v 1.10 2000/12/09 12:12:36 amos Exp $
 *
 * Apollo sound player: http://www.apolloplayer.org
 * Copyright(C) 2000 Apollo Team.  See CREDITS file.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * The GNU General Public License is also available online at:
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

#ifndef QMSONGITEM_H_INCLUDED
#define QMSONGITEM_H_INCLUDED

#include <qfileinfo.h>

#include "qmplaylistitem.h"

/*! \file qmsongitem.h
  Definition of QmSongItem class which represents a song in the playlist.
*/

class QStringList;

class QmSongItem : public QmPlayListItem
{
public:
    QmSongItem(QListView* parent, const char* filename, int count = -1);
    QmSongItem(QmPlayListItem* parent, const char* filename, int count = -1);
    virtual ~QmSongItem();

    void				setSongTitle( const QString &title );
    void				setSongLength( const QString &len );
	void 				setMark(bool mark);

    bool                isBad() const;

    virtual void 		setPlaying(bool p);
    virtual QString		filePath() const;
    virtual QString		text(int) const;
	virtual QString		save() const;
	virtual bool		isSong() const;
    virtual void 		paintCell(QPainter *p, const QColorGroup &cg, int col, int w, int a);
    virtual void 		paintFocus(QPainter *p, const QColorGroup &cg, const QRect &r);
    
    virtual QString		key( int col, bool asc ) const;

private:
    QFileInfo			m_File;
    QString     		m_Title;
    QString     		m_Length;
    bool				m_Playing;
	bool				m_IsBad;
	static int			m_ItemCount;
	static bool			m_ListLoaded;
	static QStringList 	m_BadList;
};

#endif // QMSONGITEM_H_INCLUDED
