#include <curses.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <pthread.h>
#include <X11/Xlib.h>
/* #include <djmikmod1.h>
 #include <djmikmod2.h>
*/
#include <mikmod.h>
#include "bufsize.h"
#define LBUF_SIZE 1800
/* #define CHNUM 2*/


extern struct MDRIVER drv_djsuite;
extern int startatoffset;
extern nextpattern[CHNUM];

signed short loadbuffer[BUF_SIZE*LBUF_SIZE];
int lbp, buffering=0;

signed short audiobuffer[50000];
signed short ab[BUF_SIZE];
audio_buf_info info;
int audio_fd;
int tmp;
int playerthreadworking;
int frags;

int first;
int active;
int mutexlocked;
int mixfreqcounter,mixfreqmax;
int freqadd;

pthread_mutex_t mutex;


MODULE *module[CHNUM];



Display *display;
Window w;        /* relative to which window                */
Window *rootret, *childret;      /*RETURN*/
int rootx, rooty;      /* RETURN*/
int faszom, winx[2], winy[2];    /* RETURN*/
int screen,he;
int low, band, high, d1, d2, res, cutoff,osc,osc2;
unsigned int maskret[2];
short input, buf[10000], inbuf[10000], ps[50000];   /* 5000 stereo frames */
int i,j, query, temp, psc, psc2;
signed int filled;
XButtonEvent xe;


/* STATE VARS */

int secondary=1;
int synchrostart=0;
int playing[CHNUM];
int command;
int low1l[CHNUM],band1l[CHNUM],high1l[CHNUM],cutoff1[CHNUM],reso1[CHNUM];
int low1r[CHNUM],band1r[CHNUM],high1r[CHNUM];
int low2l[CHNUM],band2l[CHNUM],high2l[CHNUM],cutoff2[CHNUM],reso2[CHNUM];
int low2r[CHNUM],band2r[CHNUM],high2r[CHNUM];
int bass[CHNUM],treble[CHNUM];
int adding[CHNUM],chnvol[CHNUM],mixfreq[CHNUM];
int ss[CHNUM],se[CHNUM],next[CHNUM],es[CHNUM],ee[CHNUM],last[CHNUM],advance[CHNUM];
float speed[CHNUM];
int initialfreq;
int longloop[CHNUM];

/* MISC */
  pthread_t thread;  
  pthread_attr_t pthread_attr_default;
  pthread_mutexattr_t pthread_mutexattr_default;
  char *setfile;
  FILE* setfileh;
  

void playerthread(void);

void procbuf(signed short *ab, int chn)
{
  int i;
  
  i=0;
  if (startatoffset)
  {
    i=offset;
    startatoffset=0;
  };
  
  if (first)
  {
    for(;i<BUF_SIZE/2;i++)
    {
/*      low1l[chn]+=((band1l[chn]*cutoff1[chn])>>12);
      band1l[chn]+=((high1l[chn]*cutoff1[chn])>>12);
      high1l[chn]=audiobuffer[i]-low1l[chn]-((band1l[chn]*reso1[chn])>>8);
      ab[i]=((bass[chn]*(low1l[chn]+((band1l[chn]*reso1[chn])>>8)))>>12)+high1l[chn];
      i++;
      low1r[chn]+=((band1r[chn]*cutoff1[chn])>>12);
      band1r[chn]+=((high1r[chn]*cutoff1[chn])>>12);
      high1r[chn]=audiobuffer[i]-low1r[chn]-((band1r[chn]*reso1[chn])>>8);
      ab[i]=((bass[chn]*(low1r[chn]+((band1r[chn]*reso1[chn])>>8)))>>12)+high1r[chn];
      
      low1l[chn]=band1l[chn];
      band1l[chn]=audiobuffer[i];
      ab[i]=((3950*(high1l[chn]-low1l[chn]+band1l[chn]))>>12);
      high1l[chn]=ab[i];
      if (bass[chn]) ab[i]=audiobuffer[i];
      i++;
      low1r[chn]=band1r[chn];
      band1r[chn]=audiobuffer[i];
      ab[i]=high1r[chn]-low1r[chn]+band1r[chn];
      high1r[chn]=ab[i];
      if (bass[chn]) ab[i]+=audiobuffer[i];
*/      
      ab[i]=audiobuffer[i];
    };
    first=0;
  }  
  else {
    for(;i<BUF_SIZE/2;i++)
    {
    /*  low1l[chn]+=((band1l[chn]*cutoff1[chn])>>12);
      band1l[chn]+=((high1l[chn]*cutoff1[chn])>>12);
      high1l[chn]=audiobuffer[i]-low1l[chn]-((band1l[chn]*reso1[chn])>>8);
      ab[i]+=((bass[chn]*(low1l[chn]+((band1l[chn]*reso1[chn])>>8)))>>12)+high1l[chn];
      i++;
      low1r[chn]+=((band1r[chn]*cutoff1[chn])>>12);
      band1r[chn]+=((high1r[chn]*cutoff1[chn])>>12);
      high1r[chn]=audiobuffer[i]-low1r[chn]-((band1r[chn]*reso1[chn])>>8);
      ab[i]+=((bass[chn]*(low1r[chn]+((band1r[chn]*reso1[chn])>>8)))>>12)+high1r[chn];
    */
      int tmp;  
      tmp=ab[i]+audiobuffer[i];
      if (tmp>32767) tmp=32767;
      if (tmp<-32767) tmp=-32767; 
      ab[i]=tmp;  
    };
  };
};




void playerthread()
{
  int i,bpm,sngspd;
  FILE *beatfile;
  char filename[255],bfilename[255];
  char modulefilename[255];
  
  for(;;)
  {
    pthread_mutex_lock(&mutex);
  
    fscanf(setfileh,"%s\n",bfilename);
    beatfile=fopen(bfilename,"r");
    fscanf(beatfile,"%s \n",filename);
    fscanf(beatfile,"%f %d %d %d %d %d %d \n",&speed[secondary],&ss[secondary],
     &se[secondary],&next[secondary], &es[secondary],&ee[secondary], &last[secondary]);
    fscanf(beatfile,"%d %d \n",&bpm,&sngspd); 
    fclose(beatfile);
    					
    printw("%s on player %d \n",filename,secondary);
/*    printw("%f %d %d %d %d %d %d \n",speed[secondary],ss[secondary],
     se[secondary],next[secondary], es[secondary],ee[secondary], last[secondary]);
*/    
    MikMod_SelectChannel(secondary);
    if (playing[secondary]) Player_Stop();
    
    if (module[secondary]) Player_Free(module[secondary]);
    module[secondary] =(MODULE *)Player_Load(filename,32,0);

    
    Player_Start(module[secondary]);
    
    
    pf->bpm=bpm;pf->sngspd=sngspd;
        
    if ((playing[0]==0)&&(playing[1]==0))
     mixfreq[secondary]=initialfreq; 
    else 
    {
      mixfreq[secondary]=(speed[1-secondary]/speed[secondary]*mixfreq[1-secondary]);
      mixfreqmax=((speed[1-secondary]/speed[secondary]*
              ((float)mixfreq[1-secondary]))-((float)mixfreq[secondary]))
	      *((float)BUF_SIZE)/44100.0;
      mixfreqcounter=0;	      
    };
    advance[secondary]=0;
    if ((se[secondary]==0)&&(ss[secondary]==0)&&(next[secondary]==0)) advance[secondary]=1;
    
    if (!advance) looping[secondary]=1;
    else looping[secondary]=0;
    
    nextpattern[secondary]=ss[secondary];
    longloop[secondary]=1;
    playing[secondary]=0;
    pthread_mutex_unlock(&mutex);
    mutexlocked=0;
    while (!mutexlocked);
  };
};

void flowcontrol(int chn)
{
  if (advance[chn]==0)
    {
          if ((pf->sngpos>=se[chn])&&(longloop[chn]))
	    {
            nextpattern[chn]=ss[chn];
	    };
          if ((pf->sngpos>=se[chn])&&(!longloop[chn]))
	    {
            nextpattern[chn]=next[chn];
            advance[chn]=1;
	    };
    };

  if (advance[chn]==1)
	  {
            if (pf->sngpos==last[chn])
            {
              longloop[chn]=1;advance[chn]=2;
              nextpattern[chn]=es[chn];
	      printw("%d reached last \n",chn);
            };
	  }

  if (advance[chn]==2)
	  {
            if ((pf->sngpos==ee[chn])&&(longloop[chn])) nextpattern[chn]=es[chn];
	  }
}

void PlayChannel(int chn, signed short *ab)
{
  MikMod_SelectChannel(chn);
  md_mixfreq=mixfreq[chn];
/*  if (chn==(1-secondary))
  {
    if (mixfreqcounter++<mixfreqmax)
      md_mixfreq++;
    if (mixfreqcounter>=(44100/BUF_SIZE)) mixfreqcounter=0;
  };*/
  if (chn==(1-secondary))
  {
    if (freqadd) 
    {  
      md_mixfreq+=freqadd;
      freqadd=0;
    };  
  };
/*  if (chn==secondary)
  {
    chnvol[chn]-=adding[chn];
    if (chnvol[chn]<0) 
    {
      chnvol[chn]=0;
      adding[chn]=0;
/*      playing[chn]=0;*/
/*    };
    if (chnvol[chn]>(128<<8))
    {
      chnvol[chn]=(128<<8);
      adding[chn]=0;
    };  
  }*/
/*  else {*/
    chnvol[chn]+=adding[chn];
    if (chnvol[chn]>(128<<8)) 
    {
      chnvol[chn]=(128<<8);
      adding[chn]=0;
    };
    if (chnvol[chn]<0)
    {
      chnvol[chn]=0;
      adding[chn]=0;
    };                
/*  };*/

  md_volume=(chnvol[chn]>>8);
  
  MikMod_Update();
  procbuf(ab,chn);
  flowcontrol(chn);
};

void InitX()
{
/*  display = XOpenDisplay(NULL);
  screen = XDefaultScreen(display);
  w=XCreateSimpleWindow(display, XRootWindow(display,screen), 0, 0, 2, 2, 1, 1,1);
  XSelectInput(display,w, KeyPressMask) ;
  XMapWindow(display,w);
  XFlush(display);
  XGrabKeyboard(display,w ,0,GrabModeAsync, GrabModeAsync, CurrentTime);*/
};

void InitCurses()
{
  initscr();cbreak();noecho();nodelay(stdscr,TRUE);
/*  mvaddstr(1,1,"Songname:");mvaddstr(1,41,"Songname:");
  mvaddstr(2,1,"Status:");mvaddstr(2,41,"Status:");
  mvaddstr(3,1,"Volume:");mvaddstr(3,41,"Volume:");
  mvaddstr(4,1,"Volume slide speed:");mvaddstr(4,41,"Volume slide speed:");*/
  refresh();
};

void drawscreen()
{


};

void InitAudio()
{
  md_mode=DMODE_SOFT_MUSIC|DMODE_STEREO|DMODE_INTERP|DMODE_16BITS|DMODE_HQMIXER;
  md_mixfreq=44100;        
  MikMod_RegisterDriver(&drv_djsuite);
  MikMod_RegisterAllLoaders();
  md_reverb=0;          
    
  if (MikMod_Init("")) 
  { 
    printw("lofasz \n");
    refresh();
  };
  MikMod_InitChannels();  
    
  audio_fd=open("/dev/dsp",O_WRONLY,0);
  tmp = AFMT_S16_LE;
  ioctl(audio_fd, SNDCTL_DSP_SETFMT, &tmp);
  tmp = 1;
  ioctl(audio_fd, SNDCTL_DSP_STEREO, &tmp);
  tmp = 44100;
  ioctl(audio_fd, SNDCTL_DSP_SPEED, &tmp);
  tmp= 0x1000000b;
  ioctl(audio_fd, SNDCTL_DSP_SETFRAGMENT, &tmp);
  ioctl(audio_fd, SNDCTL_DSP_GETOSPACE, &info);
/*  printw("fragtot: %d, size %d \n", info.fragstotal, info.fragsize);*/

}

void InitThread()
{
  pthread_attr_init(&pthread_attr_default);
  pthread_mutexattr_init(&pthread_mutexattr_default);
  pthread_mutex_init(&mutex, &pthread_mutexattr_default);
  pthread_mutex_lock(&mutex);mutexlocked=1;
  pthread_create(&thread, &pthread_attr_default, (void *)&playerthread, NULL);
}

void InitStateVars()
{
  for(i=0;i<CHNUM;i++)
  {
    low1l[i]=0;band1l[i]=0;high1l[i]=0;
    low1r[i]=0;band1r[i]=0;high1r[i]=0;
    cutoff1[i]=80;reso1[i]=1000;bass[i]=(1<<12);
    bass[i]=0;
    playing[i]=0;    
    chnvol[i]=0;adding[i]=0;
    module[i]=NULL;
  };
  secondary=0;
  onbeat[1]=1;
}

void OpenSetFile()
{
  setfileh=fopen(setfile,"r");
  fscanf(setfileh,"%d\n",&initialfreq);
}



void main(argc,argv)
int argc;
char **argv;
{
  int tmp,i,j;
  int p=0;
  int shmid;
  int pch;
  
  printf(" elindul ? \n");
  
  setfile=argv[1];
  
/*  InitX();*/
  InitCurses();
  InitAudio();
  InitThread();
  InitStateVars();
  OpenSetFile();
  
  for(;;)
  {
    ioctl(audio_fd, SNDCTL_DSP_GETOSPACE, &info);
    frags=info.fragstotal-info.fragments;
    
    if (buffering==1)
    {
      write(audio_fd, ab, BUF_SIZE);
      clear();printw("Buffering \n");refresh();
      lbp=0;
      for(i=0;i<LBUF_SIZE;i++)
       {
         first=1;
         if (playing[1-secondary]) PlayChannel(1-secondary,&(loadbuffer[i*BUF_SIZE]));
	 i++;
	 first=1;
	 if (playing[1-secondary]) PlayChannel(1-secondary,&(loadbuffer[i*BUF_SIZE]));
         write(audio_fd, &(loadbuffer[lbp]), BUF_SIZE);
         lbp+=BUF_SIZE;
       };
       first=1;
       
       if (playing[1-secondary]) PlayChannel(1-secondary,ab);
       buffering=2;
       
      for(i=0;i<16;i++)
      { 
       write(audio_fd, &(loadbuffer[lbp]), BUF_SIZE);
       lbp+=BUF_SIZE;
      };
      pthread_mutex_unlock(&mutex);
      
    }
    if (buffering==2)
        { 
	 for(;lbp<BUF_SIZE*LBUF_SIZE;lbp+=BUF_SIZE)            
          write(audio_fd, &(loadbuffer[lbp]), BUF_SIZE);
 	  if (lbp==BUF_SIZE*LBUF_SIZE) 
	  {
	    buffering=0;
	    refresh();
	    pthread_mutex_lock(&mutex);
	    mutexlocked=1;
	  };
        };
	
    if (frags<2) 
    {
     for(i=0;i<(2-frags);i++)
     {
       if (buffering==0)
       {
          write(audio_fd, ab, BUF_SIZE);
	  
	  pch=1-secondary;
          first=1;
	  
          if (playing[pch])
	  {
  	    PlayChannel(pch,ab);
          };

          if ((synchrostart==1)&&(onbeat[pch]))
	  {
	    onbeat[pch]=0;
	    playing[secondary]=1;
	    startatoffset=1;
	    synchrostart=-1;
	  };
	  if ((synchrostart==2)&&(onbeat[pch])&&(pattern[pch]))
	  {
	    onbeat[pch]=0;
	    pattern[pch]=0;
	    playing[secondary]=1;
	    startatoffset=1;
	    synchrostart=-1;
	  };
	  
	  
	  if (playing[secondary])
	  {
	    if (synchrostart==-1)
	    {
	      secondary=1-secondary;
	      synchrostart=0;
	      PlayChannel(1-secondary,ab);
	      printw("   switch !\n");
            } else PlayChannel(secondary,ab);
	  };
        }; 
        
      };
    }; 

/*     XQueryPointer(display,w,buf,buf,&rootx,&rooty,buf,buf,maskret);*/
     if ((tmp=getch())!=ERR)
     {
      switch(tmp)
       {
        case 'q':
        case 'Q':
        {
/*          XUngrabKeyboard(display, CurrentTime);*/
	  break;
        };
	case 'w':
	case 'W':
	{
	  freqadd=10;
	  break;
	};
	case 39:
	{
	  if ((playing[0]==0)&&(playing[1]==0)) 
	  {
	    onbeat[1]=1;synchrostart=1;onbeat[0]=0;
	  }
	  else 
	  {
	    MikMod_SelectChannel(1-secondary);
	    Player_Stop();
	    Player_SetPosition(ss[1-secondary]);
	    Player_Start(module[1-secondary]);
	    Player_SetPosition(ss[1-secondary]);
	    playing[1-secondary]=0;
	    secondary=1-secondary;
	  };        
	  break;
	};
        case 59:
	{
	  synchrostart=2;
	  pattern[0]=0;pattern[1]=0;onbeat[0]=0;onbeat[1]=0;
	  break;
	};
	  
        case 'a':
        case 'A':
        {
	  adding[0]=(128<<7);
	  break;
	};
	case 's':
	case 'S':
        {
	  adding[0]=(128);
	  break;
	};
	case 'd':
	case 'D':
        {
	  adding[0]=10;
	  break;
	};
	case 'f':
	case 'F':
	{
	  adding[0]=0;
	  break;
	};
	case 'g':
	case 'G':
	{
	  adding[0]=-10;
	  break;
	};  
	case 'h':
	case 'H':
	{
	  adding[0]=(-128);
	  break;
	};
	case 'j':
	case 'J':
	{
	  adding[0]=-(128<<7);
	  break;
	};  
	case 'k':
	case 'K':
	{
	  longloop[0]=0;
	  break;
	};
	case 'l':
	case 'L':
	{
	  looping[0]=1-looping[0];
	  break;
	};
	case 'z':
	case 'Z':
	{
	  adding[1]=(128<<7);
	  break;
	};
	case 'x':
	case 'X':
	{
	  adding[1]=(128);
	  break;
	};
	case 'c':
	case 'C':
	{
	  adding[1]=10;
	  break;
	};
	case 'v':
	case 'V':
	{
	  adding[1]=0;
	  break;
	};
	case 'b':
	case 'B':
	{
	  adding[1]=-10;
	  break;
	};
	case 'n':
	case 'N':
	{
	  adding[1]=(-128);
	  break;
	};
	case 'm':
	case 'M':
	{
	  adding[1]=-(128<<7);
	  break;
	};
	case ',':
	{
	  longloop[1]=0;
	  break;
	};
	case '.':
	{
	  looping[1]=1-looping[1];
	  break;
	};
	case '/':
	{
	  buffering=1;
	  break;
	};
	default:
	{
	  printw("gomb: %d \n",tmp);refresh();
	}
       };
            
    };
    
    
    
  };

  
  pthread_cancel(thread);
  
  Player_Stop();
  Player_Free(module[0]);
  Player_Free(module[1]);
  
  MikMod_Exit();
    
} 
