/*	MikMod sound library
	(c) 1998, 1999, 2000 Miodrag Vallat and others - see file AUTHORS for
	complete list.

	This library is free software; you can redistribute it and/or modify
	it under the terms of the GNU Library General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.
 
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Library General Public License for more details.
 
	You should have received a copy of the GNU Library General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
	02111-1307, USA.
*/

/*==============================================================================

  $Id: drv_stdout.c,v 1.29 2000/02/14 22:10:21 miod Exp $

  Output data to stdout
  
  modified by p.nis/dolOps for dolOps' Hobby Disc Jockey Suite

==============================================================================*/

/* # iclude "config.h" */
#include <unistd.h>
#include <stdlib.h>

#include <mikmod.h>

#include "bufsize.h"

int startatoffset=0;
extern signed short audiobuffer[50000];

static BOOL stdout_IsThere(void)
{
	return (1==1);
}

static BOOL stdout_Init(void)
{
	return VC_Init();
}

static void stdout_Exit(void)
{
	VC_Exit();
}

static void stdout_Update(void)
{
	  if (!startatoffset) offset=0;
	    
          VC_WriteBytes((SBYTE*)(&(audiobuffer[offset])),BUF_SIZE-offset);
}

static BOOL stdout_Reset(void)
{
	VC_Exit();
	return VC_Init();
}

MIKMODAPI MDRIVER drv_djsuite={
	NULL,
	"djsuite",
	"DJ Suite driver v1.0",
	0,255,
	"djsuite",

	NULL,
	stdout_IsThere,
	VC_SampleLoad,
	VC_SampleUnload,
	VC_SampleSpace,
	VC_SampleLength,
	stdout_Init,
	stdout_Exit,
	stdout_Reset,
	VC_SetNumVoices,
	VC_PlayStart,
	VC_PlayStop,
	stdout_Update,
	NULL,
	VC_VoiceSetVolume,
	VC_VoiceGetVolume,
	VC_VoiceSetFrequency,
	VC_VoiceGetFrequency,
	VC_VoiceSetPanning,
	VC_VoiceGetPanning,
	VC_VoicePlay,
	VC_VoiceStop,
	VC_VoiceStopped,
	VC_VoiceGetPosition,
	VC_VoiceRealVolume,
	VC_VoiceSetFilter
};

