/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  This file is part of MixMagic.

    Copyright (C) 2000 Jonas Borgstrm <jonas_b@bitsmart.com>.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
#include <gnome.h>
#include <locale.h>

#include "mixmagic.h"
#include "stock.h"
#include "plugins.h"
#include "preferences.h"

Preferences *prefs = NULL;

/*
 * Initializes the application.
 */
void
application_init (gint argc, gchar **argv)
{
	/* 
	 * Set the numeric locale to en_US.
	 * Else atof might fail if the string was printed on another locale
	 */
	gnome_init (PACKAGE, VERSION, argc, argv);
	stock_init ();
	plugins_init ();

	prefs = g_new0 (Preferences, 1);
	preferences_load (prefs);

	setlocale (LC_NUMERIC, "en_US");
}

/*
 * Starts up the GUI.
*/
void
application_start ()
{
	gtk_main ();
}
