/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  This file is part of MixMagic.

    Copyright (C) 2000 Jonas Borgstrm <jonas_b@bitsmart.com>.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __MIXMAGIC_INDEX_H__
#define __MIXMAGIC_INDEX_H__

#include <gnome.h>

#ifndef SAMPLE_DEFINED
#define SAMPLE_DEFINED
typedef struct _Sample Sample;
#endif
typedef struct _Index Index;

struct _Index {
	gchar *filename;

	gpointer data;

	gint fd;

	gint map_size;
};

Index *		index_new		(Sample *sample, GnomeAppBar *appbar);
gboolean	index_create		(Index *index, Sample *sample, GnomeAppBar *appbar);
void		index_destroy		(Index *index);
guint8		index_get_average	(Index *index, gint offset, gint start, gint length, gint loop_length);

#endif
