/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*  This file is part of MixMagic.

    Copyright (C) 2000 Jonas Borgstrm <jonas_b@bitsmart.com>.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/

#ifndef __MIXMAGIC_LOOPBLOCK_H__
#define __MIXMAGIC_LOOPBLOCK_H__

#include <gtk/gtk.h>
#include <tree.h>
#include <parser.h>
#include "mixmagic.h"
#include "block.h"

typedef struct _LoopBlock LoopBlock;
typedef struct _LoopBlockClass  LoopBlockClass;

#define LOOPBLOCK(obj)         GTK_CHECK_CAST(obj, loopblock_get_type (), LoopBlock)
#define LOOPBLOCK_CLASS(klass)  GTK_CHECK_CLASS_CAST(klass, loopblock_get_type (), LoopBlockClass)
#define IS_LOOPBLOCK(obj)       GTK_CHECK_TYPE(obj, loopblock_get_type ())

struct _LoopBlock {
	Block block;

	gint loop_length;
	gint loop_start;
};

struct _LoopBlockClass 
{
        BlockClass parent_class;
};

guint		loopblock_get_type		(void);
GtkWidget*	loopblock_new			(Track *track);
GtkWidget*	loopblock_new_from_block	(Block *block, Track *track);
void		loopblock_load 			(Song *song, Track *track, xmlNodePtr node, xmlNsPtr ns, gint track_num);
#endif
